﻿package {	
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.filters.BlurFilter;
	import flash.geom.Point;
	import flash.events.Event;
	public class Particles1 extends Sprite{
		private var bmpData:BitmapData;
		private var filterObj:BlurFilter = new BlurFilter(10,10,5);
		private var particuleCollection:Array=[];
		private var couleursCollection:Array=[0xffff0000,0xffffffff];
		public function Particles1(){
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void{
			bmpData = new BitmapData(stage.stageWidth,stage.stageHeight,true,0);
			addChild(new Bitmap(bmpData)) as Bitmap;
			addEventListener(Event.ENTER_FRAME,boucle);
		}
		private function boucle(e:Event):void{
			for(var i:int=0;i<100;i++){
				//var angle:int=Math.round(Math.random()*360);
				var angle:int = Math.round(i * 3.6);
				creationDeParticules(Math.cos(angle/180*Math.PI)*10,Math.sin(angle/180*Math.PI)*10,couleursCollection[Math.round(Math.random())],mouseX,mouseY);
			}
			var o:int = particuleCollection.length;
			bmpData.applyFilter(bmpData,bmpData.rect,new Point(0,0),filterObj);
			bmpData.lock();
			while(o--) {
				var p:Object = particuleCollection[o];
				p.x+=p.vx;
				p.y+=p.vy;
				p.vx*=.95;
				p.vy*=.95;
				bmpData.setPixel32(p.x,p.y,p.c);
				if (p.vx+p.vy<0.2 && p.vx+p.vy>-0.2){particuleCollection.splice(o,1);}
			}
			bmpData.unlock();
		}
		private function creationDeParticules(vitesseX:Number, vitesseY:Number, couleur:uint, positionX:Number=0, positionY:Number=0):void {
			var particule:Object = {};
			particule.x = positionX;
			particule.y = positionY;
			particule.vx = vitesseX;
			particule.vy = vitesseY;
			particule.c = couleur;
			particuleCollection.push(particule);
		}
	}
}